var port;
var ws;
var open = false;
var currentUrl;

function getUserPort() {
    if (navigator.platform.startsWith('Mac') || navigator.platform.startsWith('Linux')) {
        port = 52419;
    } else {
        var fcli = chrome.runtime.connectNative('com.viafirma.fortress.firefox.host');
        fcli.onMessage.addListener(function (msg) {
        	port = msg.text;
            fcli.disconnect();
        });
    }
}

var onOpen = function() {
	sendCurrentUrl();
};

var onClose = function() {
	ws = null;
};

var onError = function () {
	port = null;
	ws = null;
};

function openws() {
	ws = new WebSocket('ws://localhost:' + port);
	ws.onopen = onOpen;
	ws.onclose = onClose;
	ws.onerror = onError;
}

function sendCurrentUrl() {
	if (port == null) {
		getUserPort();
	} else if (ws == null) {
		openws();
	} else if (ws.readyState === 1) {
		chrome.tabs.query({'active': true, 'lastFocusedWindow': true}, function (tabs) {
			currentUrl = tabs[0].url;
			ws.send('firefox|' + currentUrl);
		});
	}
}

var t = setInterval(sendCurrentUrl, 500);